#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <dlfcn.h>
#include "inkview.h"
#include <dirent.h>
#include <math.h>

#include <time.h>		// for the sake of access date 
time_t rawtime;
struct tm* clocky;		// create a time structure
struct stat attrib;		// create a file attribute structure
struct stat attrib2;


char *about = "Books History\n\nVersion 2.0 beta 5\n\nhttp://tiny.cc/histor";
char *about_rus = "История открытых книг\n\nВерсия 2.0 beta 5\n\nhttp://tiny.cc/histor";

char *default_font = "LiberationSans";
char *default_font_bold = "LiberationSans-Italic";

int main_handler(int type, int par1, int par2);
ifont *myfont;
ifont *myfontbold;
char kbuffer[256];
char kbuffer2[256];
char kbuffer3[256];
char kbuffer4[256];
char book[256];
char empty[256];
char ss2[256];
int e; // sign of the english language
iconfig *ini;
int is_in_select_mode=0;
int file_mode=0;
int fpage = 1; // page  for file mode
int sort_mode = 2;
int hidefiles = 0;
int dir_sorty = 0;
int date_sorty = 0;
int there_is_dir = 0;
int ii;
int iii;
int books_in_dir;
int i;
int fpage_from;
int fpage_to;
int myfontsize; // (14)
int gap;	// gap between lines (26)
int cursor = 0;	// position 0..29
int cursor_fm= 0;	// position 0..29
int oldcursor;
int oldcursor_fm;
int cursor_up[99];	// position for dir up
int fpage_up[99];	// position for dir up
int dir_level = 50; // let it be 50 :)
int booksa = 0;	// amount of books
int booksa_fm = 0;	// amount of files on this page (file mode)
int badbooksa = 0;	// amount of deleted books
int badbooks[50];	// and they are
int is_long = 0;	// sign of long key press

int keep_scandir = 0;
char now_dir[256];	// full path
DIR *dir;
struct dirent **entry;


char lastbooksfile[] = LASTOPENBOOKS;	// STATEPATH "/lastopen.txt"
char lastbooksfile_save[] = STATEPATH "/lastopen_save.txt";

int cindex=166;
imenu menu1[] = {
	{ ITEM_ACTIVE, 110, "Move to top", NULL },
	{ ITEM_ACTIVE, 120, "Remove", NULL },
	{ ITEM_ACTIVE, 130, "Info", NULL },
	{ ITEM_ACTIVE, 150, "Open", NULL },
	{ ITEM_ACTIVE, 166, "Read mark", NULL },
	{ ITEM_ACTIVE, 177, "Open folder", NULL },
	{ ITEM_ACTIVE, 160, "Select", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 997, "File manager", NULL },
	{ ITEM_ACTIVE, 998, "Configuration", NULL },
	{ ITEM_ACTIVE, 999, "About", NULL },
	{ ITEM_ACTIVE, 777, "Exit", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 210, "Save session", NULL },
	{ ITEM_ACTIVE, 220, "Load session", NULL },
	{ ITEM_ACTIVE, 140, "Remove deleted books", NULL },
	{ 0, 0, NULL, NULL }
};
imenu menu1_rus[] = {
	{ ITEM_ACTIVE, 110, "Переместить вверх", NULL },
	{ ITEM_ACTIVE, 120, "Убрать из списка", NULL },
	{ ITEM_ACTIVE, 130, "Информация", NULL },
	{ ITEM_ACTIVE, 150, "Открыть", NULL },
	{ ITEM_ACTIVE, 166, "Пометка о прочтении", NULL },
	{ ITEM_ACTIVE, 177, "Открыть папку", NULL },
	{ ITEM_ACTIVE, 160, "Выбрать", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 997, "Книжная полка", NULL },
	{ ITEM_ACTIVE, 998, "Настройки", NULL },
	{ ITEM_ACTIVE, 999, "О программе", NULL },
	{ ITEM_ACTIVE, 777, "Выход", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 210, "Сохранить список", NULL },
	{ ITEM_ACTIVE, 220, "Загрузить список", NULL },
	{ ITEM_ACTIVE, 140, "Убрать удаленные книги", NULL },
	{ 0, 0, NULL, NULL }
};
// ! ! ! don't forget to change it if menu1 was changed:
int remove_deleted_books_index = 15;	int select_index = 6; 


int cindex_filemode = 160;
imenu menu_filemode_sort[] = {
	{ ITEM_ACTIVE, 404, "Title", NULL },
	{ ITEM_ACTIVE, 401, "File name", NULL },
	{ ITEM_BULLET, 402, "Date", NULL },
	{ ITEM_ACTIVE, 403, "Status", NULL },
	{ ITEM_ACTIVE, 405, "Type", NULL },
	{ 0, 0, NULL, NULL }
};
imenu menu_filemode[] = {
	{ ITEM_ACTIVE, 110, "Open and add to history", NULL },
	{ ITEM_ACTIVE, 120, "Add to history", NULL },
	{ ITEM_ACTIVE, 130, "Open", NULL },
	{ ITEM_ACTIVE, 150, "Info", NULL },
	{ ITEM_ACTIVE, 170, "Delete", NULL },
	{ ITEM_ACTIVE, 180, "Edit", NULL },
	{ ITEM_ACTIVE, 160, "Read mark", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 997, "History", NULL },
	{ ITEM_ACTIVE, 999, "About", NULL },
	{ ITEM_ACTIVE, 777, "Exit", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_SUBMENU, 400, "Sort by", menu_filemode_sort },
	{ 0, 0, NULL, NULL }
};
imenu menu_filemode_dir[] = {		// for folders
	{ ITEM_ACTIVE, 130, "Open", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 997, "History", NULL },
	{ ITEM_ACTIVE, 999, "About", NULL },
	{ ITEM_ACTIVE, 777, "Exit", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_SUBMENU, 400, "Sort by", menu_filemode_sort },
	{ 0, 0, NULL, NULL }
};


extern const ibitmap ci_zoomin, ci_font;
static iconfigedit testce[] = {
	{ CFG_FONTFACE, &ci_font, "Font", NULL, "font", NULL, NULL, NULL },
	{ CFG_NUMBER, &ci_zoomin, "Font size",  NULL, "fontsize", NULL, NULL, NULL },
	{ 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
};

static iconfigedit testce_rus[] = {
	{ CFG_FONTFACE, &ci_font, "Шрифт", NULL, "font", NULL, NULL, NULL },
	{ CFG_NUMBER, &ci_zoomin, "Размер шрифта",  NULL, "fontsize", NULL, NULL, NULL },
	{ 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
};


char* GetFileExt(char* fname){
	char fext[256];
	int q = 0;
	int u = 0;
	for (q =strlen(fname); q >= 0; q--) if (fname[q] == '.') break;
	if (q == 0) return strdup("");
	for (q = q + 1, u=0; q<strlen(fname) && u < 4; q++, u++) fext[u]=fname[q];	// max 4
	fext[u] = '\0';
	return strdup(fext);
}


int scandir_sel(const struct dirent *d){		// for scandir()
    if (d->d_name[0] == '.') return 0; else return 1;
}

int alphasort_dir(const struct dirent **a, const struct dirent **b){	// for scandir()
	strcpy(empty, now_dir);
	strcpy(ss2, now_dir);
	strcat(empty, (*a)->d_name);
	strcat(ss2, (*b)->d_name);
	stat(empty, &attrib);
	stat(ss2, &attrib2);
	dir_sorty = 0;
	there_is_dir = 0;
	if (attrib.st_mode & S_IFDIR) { dir_sorty--; there_is_dir = 1; }
	if (attrib2.st_mode & S_IFDIR) { dir_sorty++; there_is_dir = 1; }
	if (dir_sorty != 0) return dir_sorty; // ONE of them is dir			dir sort is more important in any case
	
	if (sort_mode == 1 || (sort_mode == 4 && there_is_dir == 1)) return strcmp((*a)->d_name, (*b)->d_name);		// by name
	if (sort_mode == 4 && there_is_dir == 0) return strcmp(GetBookInfo(empty)->title, GetBookInfo(ss2)->title);		// by title
	if (sort_mode == 5 && there_is_dir == 0) { i = strcmp(GetFileExt(empty), GetFileExt(ss2)); if (i) return i; } 		// by type	-	only if different ext
	
	if (sort_mode == 3 && there_is_dir == 0){	// by status
		for (i=10; i<=strlen(empty); i++) kbuffer3[i-10] = empty[i];
		for (i=10; i<=strlen(ss2); i++) kbuffer4[i-10] = ss2[i];
		sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", kbuffer3, ".afz");
		sprintf(kbuffer2, "%s%s%s", "/mnt/ext1/system/state/", kbuffer4, ".afz"); 
		i = access(kbuffer, 0);
		ii = access(kbuffer2, 0);
		if ((i != 0) && (ii == 0)) return -1; else if ((i == 0) && (ii != 0)) return 1;	// one compleated
		if ((i != 0) && (ii != 0)){	// not compleated... may be they were opened?
			sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", kbuffer3, ".af0");
			sprintf(kbuffer2, "%s%s%s", "/mnt/ext1/system/state/", kbuffer4, ".af0");
			i = access(kbuffer, 0);
			ii = access(kbuffer2, 0);
			if ((i != 0) && (ii == 0)) return -1; else if ((i == 0) && (ii != 0)) return 1;	// one was opened
		}
		// same status - just sort by date ....
	}

	if (attrib.st_mtime > attrib2.st_mtime) date_sorty = -1; else if (attrib.st_mtime < attrib2.st_mtime) date_sorty = 1; else date_sorty = 0; 
	return date_sorty;
}


void MoveCursor_file_mode(int shift) {	
	oldcursor_fm = cursor_fm;
	cursor_fm = cursor_fm + shift;
	if (cursor_fm < 0) cursor_fm = cursor_fm + booksa_fm;
	if (cursor_fm >= booksa_fm) cursor_fm = cursor_fm - booksa_fm;
	if (cursor_fm < 0) cursor_fm = booksa_fm - 1;
	if (cursor_fm >= booksa_fm) cursor_fm = 0;
	if (shift != 0) InvertAreaBW(0, 10+oldcursor_fm*gap, ScreenWidth(), myfontsize+4);
	InvertAreaBW(0, 10+cursor_fm*gap, ScreenWidth(), myfontsize+4);
	SoftUpdate();
}

void MoveCursor(int shift) {
	if (file_mode) { MoveCursor_file_mode(shift); return; }
	if ((booksa - badbooksa) > 1) {
		oldcursor = cursor;
		cursor = cursor + shift;
		if (cursor < 0) cursor = cursor + booksa;
		if (cursor >= booksa) cursor = cursor - booksa;
		while (badbooks[cursor] == 1) { 
			if (shift < 0) cursor--; else cursor++;
			if (cursor < 0) cursor = cursor + booksa;
			if (cursor >= booksa) cursor = cursor - booksa;
		}
		if (shift != 0) InvertAreaBW(0, 10+oldcursor*gap, ScreenWidth(), myfontsize+4);
	}
	InvertAreaBW(0, 10+cursor*gap, ScreenWidth(), myfontsize+4);
	SoftUpdate();
}


void GetBookFileMode(int n){	
	if (n == -1) {		// from cursor
		i = 0;
		for(ii=fpage_from; ii<books_in_dir && ii<fpage_to; ii++){
			//if (entry[ii]->d_name[0] == '.') continue;
			if (i == cursor_fm) break;
			i++;
		}
	} else {	// from array
		 ii = n; 
	}
	strcpy(book, now_dir);
	strcat(book, entry[ii]->d_name);
}

void DirUp(){
	if (strlen(now_dir) < 3) return;

							char* p;
							for (p = now_dir; *p && (p < (now_dir+sizeof(now_dir))); p++); // ищем конец строки
							p--; // слезаем с завершающего нуля
							*p = 0; // шлепаем ноль на "/"
							p--;
							while ((p >= now_dir) && *p != '/') p--; // откатываемся до "/"
							p++;       // ставим указатель 
							*p = 0; // шлепаем ноль
							
	dir_level--;
	cursor_fm = cursor_up[dir_level];
	fpage = fpage_up[dir_level]>0 ? fpage_up[dir_level] : 1;
}

void mainscreen_repaint_file_mode() {
	if (!keep_scandir) books_in_dir = scandir(now_dir, &entry, scandir_sel, alphasort_dir);
	keep_scandir = 0;
	ClearScreen();
	booksa_fm = 0;
	hidefiles = 0;
	fpage_from = fpage*30-30;
	fpage_to = fpage*30;
	for(ii=fpage_from; ii<books_in_dir && ii<fpage_to; ii++){
		//if (entry[ii]->d_name[0] == '.') { hidefiles++; continue;	}	// hide some files
		GetBookFileMode(ii);
		stat(book, &attrib);
		if (attrib.st_mode & S_IFDIR){	// dir
			SetFont(myfontbold, BLACK);
			DrawString(20, 10+booksa_fm*gap, entry[ii]->d_name);
		}else{	// file
			SetFont(myfont, BLACK);
			for (i=10; i<=strlen(book); i++) ss2[i-10] = book[i];	// filename + some path
			sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", ss2, ".afz");
			i = StringWidth("MMMM");
			if (access(kbuffer, 0) == 0) FillArea(i, myfontsize+booksa_fm*gap, 7, 7, BLACK); else{	//	completed book
					sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", ss2, ".af0");
					if (access(kbuffer, 0) == 0) DrawRect(i, myfontsize+booksa_fm*gap, 7, 7, DGRAY); //	opened book
			}
			DrawString(i+15, 10+booksa_fm*gap, GetBookInfo(book)->title);
			SetFont(myfont, DGRAY);
			DrawString(10, 10+booksa_fm*gap, GetFileExt(book));
		}
		booksa_fm++;
    }
	
	if (books_in_dir < 1){
		Message(ICON_ERROR, e?"Ops..":"Упс..", e?"This folder is empty!":"Эта папка пуста!", 500);
		DirUp();
		mainscreen_repaint_file_mode();
		return;
	}
	
	//free(entry);
	SetFont(myfont, BLACK);
	//DrawString(3, ScreenHeight()-myfontsize-10, now_dir);	// path
	if (books_in_dir > 30) sprintf(kbuffer, "%i / %i   %i", fpage, 1+((books_in_dir) / 30), books_in_dir); else sprintf(kbuffer, "%i", books_in_dir-hidefiles);
	DrawString(ScreenWidth()-StringWidth(kbuffer)-5, ScreenHeight()-myfontsize-3, kbuffer);
	MoveCursor_file_mode(0);
	

}

void mainscreen_repaint(int show_saved) {
	if (file_mode) { mainscreen_repaint_file_mode(); return;}
	ClearScreen();
	SetFont(myfont, BLACK);
	FILE *fff;
	if (show_saved){ fff = iv_fopen(lastbooksfile_save, "rt"); }else{ fff = iv_fopen(lastbooksfile, "rt"); }
	char sss[256];
	int i = 0;
	int topten = 0;
	badbooksa = 0;
	booksa = 0;
	for (i=0; i<30; i++) badbooks[i] = 0;
	while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (!feof(fff)) sss[strlen(sss)-1] = '\0'; else break;
		for (i=10; i<=strlen(sss); i++) ss2[i-10] = sss[i];
		if (access(sss, 4) == 0){
			SetFont(myfont, BLACK);
			DrawString(18, 10+booksa*gap, GetBookInfo(sss)->title);
			sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", ss2, ".afz");
			if (access(kbuffer, 0) == 0) FillArea(5, myfontsize+booksa*gap, 7, 7, BLACK);
		}else{ 
			badbooksa++;
			badbooks[booksa] = 1;
			SetFont(myfont, LGRAY);
			DrawString(18, 10+booksa*gap, ss2);
		}
		booksa++;
		if ((booksa - badbooksa) == 10 && topten == 0) {
			topten = booksa - 1;
			DrawRect(0, booksa*gap + myfontsize/2, ScreenWidth(), 1, BLACK);
		}
	}
	fclose(fff);
	if (badbooksa == 0) { menu1[remove_deleted_books_index].type = 0; menu1_rus[remove_deleted_books_index].type = 0; } 
		else { menu1[remove_deleted_books_index].type = 2; menu1_rus[remove_deleted_books_index].type = 2; }
	sprintf(kbuffer, "%i°", GetTemperature()); 
	DrawString(ScreenWidth()-StringWidth(kbuffer)-3, ScreenHeight()-myfontsize-3, kbuffer);
	MoveCursor(0);
}


void EnterDir(){
		GetBookFileMode(-1);
		stat(book, &attrib);
		if (attrib.st_mode & S_IFDIR){	// dir
				if (strcmp(entry[ii]->d_name, "..") == 0){	// up!
					DirUp();
				}else{	// enter dir
					strcat(now_dir, entry[ii]->d_name);
					strcat(now_dir, "/");
					cursor_up[dir_level] = cursor_fm;
					fpage_up[dir_level] = fpage;
					dir_level++;
					cursor_fm = 0;
					fpage = 1;
				}
		}else{	// open file
				ShowHourglass();
				OpenBook(book, NULL, 0);
		}
		//free(entry);
		mainscreen_repaint(0);
}

void SetNowDir(){
	strcpy(now_dir, SDCARDDIR);
	strcat(now_dir, "/");
	strcpy(now_dir, ReadString(ini, "dir", now_dir));
}




// int type: 0 - to top; 1 - remove; 2 - remove all deleted; 3 - add book
void BookChange(int page, int type) {
	FILE *ffw = fopen(TEMPDIR "/lastopen.tmp", "w+");
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	char sss [256];
	iii = 0;
	if (type == 0) while( !feof(fff) ) {		// 1 to top
		fgets(sss, 256, fff);
		if (iii == page){ fputs(sss, ffw); break; }
		iii++;
	}
	rewind(fff);
	iii = 0;
	while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (feof(fff)) break;
		if ((type == 2) && (badbooks[iii] == 1)) { iii++; continue; }	// not add deleted
		if ((type == 2) || (type == 3) || (iii != page)) fputs(sss, ffw);	// add the rest
		iii++;
	}
	fclose(fff);
	FILE *ffn = fopen(lastbooksfile, "w+");
	if (type == 3) { fputs(book, ffn); fputs("\n", ffn); }
	rewind(ffw);
	while( !feof(ffw) ) {	// copy all 
		fgets(sss, 256, ffw);
		if (feof(ffw)) break;
		fputs(sss, ffn);
	}
	fclose(ffn); 
	fclose(ffw); 
	mainscreen_repaint(0);
}

void GetBook(int i){
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	int iii = 0;
	while( !feof(fff) ) {
		fgets(book, 256, fff);
		if (iii == i) { 
			if (!feof(fff)) book[strlen(book)-1] = '\0'; else break;
			fclose(fff);
			return;
		}
		iii++;
	}
	fclose(fff); 
	return;
}

void ShowInfo(int i){
	char *ss3;
	char ss4[256];
	char ss5[256];
	if (file_mode == 0) GetBook(i); else GetBookFileMode(-1);
	if (access(book, 4) != 0) {
		Message(ICON_ERROR, book, e?"Access denied!":"Нет доступа!", 2000);
		return;
	}
	ss3 = GetBookInfo(book)->path;
	for (i=10; i<=strlen(ss3); i++) ss2[i-10] = ss3[i];	// filename
	
	sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", ss2, ".af0");
	stat(kbuffer, &attrib);
	clocky = gmtime(&(attrib.st_mtime));	// Get the last modified time; st_atime - access time
	sprintf(ss4, "%i.%i.%i", clocky->tm_mday, clocky->tm_mon+1, clocky->tm_year+1900);
			
	stat(ss3, &attrib);
	clocky = gmtime(&(attrib.st_mtime));	// Get the last modified time; st_atime - access time
	sprintf(ss5, "%i.%i.%i", clocky->tm_mday, clocky->tm_mon+1, clocky->tm_year+1900);
	
	time(&rawtime); clocky = localtime(&rawtime); strftime(empty, 80, "%H:%M  %A  %d %B %Y", clocky);
	
	sprintf(kbuffer, e?"%s\n\n%i kB\nCreated: %s\nOpened: %s\n\nBattery: %i%%  %i°C\n%s":"%s\n\n%i кБ\nСоздан: %s\nОткрыт: %s\n\nБатарея: %i%%  %i°C\n%s", ss2, (int)(GetBookInfo(book)->size/1000), ss5, ss4, GetBatteryPower(), GetTemperature(), empty);
	Message(0, file_mode?GetFileExt(book):GetBookInfo(book)->typedesc, kbuffer, 10000);	// inkview рушился при получении typedesc у незнакомых типов файлов 
}


void SaveSession() {
	FILE *ffw = fopen(lastbooksfile_save, "w+");
	FILE *fff = iv_fopen(lastbooksfile, "rt");
	char sss [256];
	strcpy(ss2, sss);
	strcpy(empty, sss);
	while( !feof(fff) ) {
		fgets(sss, 256, fff);
		if (strcmp(sss, ss2) != 0 || strcmp(ss2, empty) == 0) fputs(sss, ffw);
		strcpy(ss2, sss);
	}
	fclose(fff); 
	fclose(ffw);
	Message(ICON_INFORMATION, e?"Info":"Информация", e?"Session saved":"Список сохранен", 2000);
}

void LoadSession(int button) {
	if (button != 1) {
		mainscreen_repaint(0);
		return;
	}
	FILE *fff = iv_fopen(lastbooksfile_save, "rt");
	if (fff){
		char sss [256];
		strcpy(ss2, sss);
		strcpy(empty, sss);
		FILE *ffw = fopen(lastbooksfile, "w+");
		while( !feof(fff) ) {
			fgets(sss, 256, fff);
			if (strcmp(sss, ss2) != 0 || strcmp(ss2, empty) == 0) fputs(sss, ffw);
			strcpy(ss2, sss);
		}
		fclose(fff); 
		fclose(ffw);
	}else{
		Message(ICON_ERROR, e?"Error":"Ошибка", e?"There is no session to load":"Нет сохраненного списка", 3000);
	}
	mainscreen_repaint(0);
}


void change_fontsize(int fs) {	// for OpenPageSelector
	is_long = 0;
	if (fs){
		myfontsize = fs;
		myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
		WriteInt(ini, "fontsize", fs);
		mainscreen_repaint(0);
	}
}

void change_font() {	// for OpenConfigEditor
	is_long = 0;
	myfontsize = ReadInt(ini, "fontsize", 17);
	myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
	myfontbold = OpenFont(ReadString(ini, "font.i", default_font_bold), myfontsize, 0);
	mainscreen_repaint(0);
}

void del_file(){ GetBookFileMode(-1); iv_unlink(book); mainscreen_repaint_file_mode(); }

void MarkRead(){
	for (i=10; i<=strlen(book); i++) ss2[i-10] = book[i];	// filename + some path
	sprintf(kbuffer, "%s%s%s", "/mnt/ext1/system/state/", ss2, ".afz");
	if (access(kbuffer, 0) == 0) iv_unlink(kbuffer); else SetReadMarker(book, 1);
}

void SetSortMode(){
	i = 0;
	while (menu_filemode_sort[i].type) { 
		if (menu_filemode_sort[i].index == sort_mode + 400) menu_filemode_sort[i].type = ITEM_BULLET; else menu_filemode_sort[i].type = ITEM_ACTIVE; 	
		i++; 
	}
}

void menu1_handler(int index) {
	cindex = index;
	switch (index) {
		case 110:
			BookChange(cursor, 0);
			break;

		case 120:
			BookChange(cursor, 1);
			break;

		case 130: 
			ShowInfo(cursor);
			break;

		case 140:
			BookChange(cursor, 2);
			break;

		case 150:
			ShowHourglass();
			GetBook(cursor);
			OpenBook(book, NULL, 0);
			break;
			
		case 166:
			GetBook(cursor);
			MarkRead();
			mainscreen_repaint(0);
			break;
			
		case 177:
			GetBook(cursor);
			strcpy(now_dir, book);
			DirUp();
			file_mode = 1;
			mainscreen_repaint(0);
			break;

		case 160:
			GetBook(cursor);
			fprintf(stderr, "%s\n", book);
			CloseApp();
			break;
			
		case 777:
			CloseApp();
			break;
			
		case 999:
			Message(0, e?"About":"О программе", e?about:about_rus, 99999);
			break;		
			
		case 997:
			if (file_mode == 0) file_mode = 1; else file_mode = 0;
			mainscreen_repaint(0);
			break;
			
		case 998:
			OpenConfigEditor(e?"Configuration":"Настройки", ini, e?testce:testce_rus, change_font, NULL); /*OpenPageSelector(change_fontsize);*/ 
			break;
			
		case 210:
			SaveSession();
			break;
			
		case 220:
			if (access(lastbooksfile_save, 4) == 0){
				mainscreen_repaint(1);
				Dialog(ICON_QUESTION, e?"Load session":"Загрузка списка", e?"Do you want to load this session?":"Загрузить этот список?", e?"Yes":"Да", e?"No":"Нет", LoadSession);
			}else{
				Message(ICON_ERROR, e?"Error":"Ошибка", e?"There is no session to load":"Нет сохраненного списка", 3000);
			}
			break;
	}
}



void menu_handler_filemode(int index) {
	cindex_filemode = index;
	
	if (index > 400 && index < 410) {	// sort mode
		sort_mode = index - 400;
		SetSortMode();
		mainscreen_repaint_file_mode();
	}
	
	switch (index) {
		case 160:
			GetBookFileMode(-1);
			MarkRead();
			mainscreen_repaint_file_mode();
			break;
				
		case 110: // open and add to history
			GetBookFileMode(-1);
			BookChange(-1, 3);
			EnterDir();
			break;		
		
		case 120: // add to history
			GetBookFileMode(-1);
			BookChange(-1, 3);
			break;		
			
		case 130:  // open
			EnterDir();
			break;		
			
		case 170:  
			Dialog(ICON_QUESTION, e?"Delete file":"Удаление файла", e?"Do you want to delete it?":"Удалить?", e?"Yes":"Да", e?"No":"Нет", del_file);
			break;			
			
		case 180:  
			GetBookFileMode(-1);
#ifdef _PRO_
			execl("/mnt/ext1/applications/pi.app", "-f", book, NULL);
#else
			execl("/mnt/ext1/games/pi.app", "-f", book, NULL);
#endif
			break;		
			
		case 150: 
			ShowInfo(cursor_fm);
			break;

		case 777:
			CloseApp();
			break;
			
		case 999:
			Message(0, e?"About":"О программе", e?about:about_rus, 99999);
			break;		
			
		case 997:
			if (file_mode == 0) file_mode = 1; else file_mode = 0;
			mainscreen_repaint(0);
			break;
			
	}
}


void Open_Menu(){
	i = file_mode ? cursor_fm : cursor;
	if (!file_mode){
		OpenMenu(e?menu1:menu1_rus, cindex, 200, i*gap + 15, menu1_handler); 
	}else{ 
		GetBookFileMode(-1);
		stat(book, &attrib);
		OpenMenu((attrib.st_mode & S_IFDIR)?menu_filemode_dir:menu_filemode, cindex_filemode, 200, i*gap + 15, menu_handler_filemode);
	}
}

int main_handler(int type, int par1, int par2) {
 
	if (type == EVT_INIT) {	// occurs once at startup, only in main handler
		if (GetOrientation() != 0 && GetOrientation() != 3) { SetOrientation(0); }
		SetOrientation(0);
	    if (ScreenHeight() > 800) {
			myfontsize = ScreenHeight() / 50;
			gap = ScreenHeight() / 30;
	    } else {
			myfontsize = ScreenHeight() / 45;
			gap = ScreenHeight() / 30;
	    }
		ini = OpenConfig(CONFIGPATH "/history.ini", NULL);
		if (ReadInt(ini, "sort_mode", 0)) sort_mode = ReadInt(ini, "sort_mode", 0); else WriteInt(ini, "sort_mode", sort_mode);	
		SetSortMode();
		if (ReadInt(ini, "fontsize", 0)) myfontsize = ReadInt(ini, "fontsize", 0); else WriteInt(ini, "fontsize", myfontsize);
		if (strcmp(ReadString(ini, "font", ""), "") == 0) WriteString(ini, "font", default_font);
		myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
		myfontbold = OpenFont(ReadString(ini, "font.i", default_font_bold), myfontsize, 0);
		iconfig *gc = GetGlobalConfig(); 
		if (strcmp(ReadString(gc, "language", "en") , "ru") == 0) e = 0; else e = 1; // language detect
		SetNowDir();
	}

	if (type == EVT_SHOW) {	// occurs when this event handler becomes active
		mainscreen_repaint(0);
	}

	if (type == EVT_POINTERDOWN) { 	//CalibrateTouchpanel();
		if (file_mode){
			i = ((par2 * 30) / ScreenHeight()) - cursor_fm;
			//oldcursor_fm = i;
			if (i) MoveCursor_file_mode(i);
		}else{
			i = ((par2 * 30) / ScreenHeight()) - cursor;
			//oldcursor = i;
			if (i) MoveCursor(i);
		}
		Open_Menu();
	}

	if (type == EVT_KEYREPEAT) { switch (par1) {
			case KEY_LEFT: CloseApp();   	is_long = 1; break;
			case KEY_RIGHT: if (!file_mode) MoveCursor(10); else if (fpage*30 < books_in_dir){ fpage++; keep_scandir = 1; mainscreen_repaint(0); }	is_long = 1; break;
			case KEY_UP: MoveCursor(-1); break;
			case KEY_DOWN: MoveCursor(1); break;
			case KEY_OK: is_long = 1; Open_Menu(); break;
	} }

	if (type == EVT_KEYUP) { switch (par1) {
			case KEY_OK:
				if (is_long == 0) {
					if (!file_mode){
						ShowHourglass();
						GetBook(cursor);
						if(!is_in_select_mode) {
							OpenBook(book, NULL, 0);
						} else {
							fprintf (stderr, "%s\n", book);
							CloseApp();
						}
					}else{
						EnterDir();
					}
				}
				is_long = 0;
				break;
				
			case KEY_LEFT: 
				if (is_long == 0){ if (!file_mode) MoveCursor(-5); else if (fpage > 1){ fpage--; keep_scandir = 1; mainscreen_repaint(0); } else { DirUp(); mainscreen_repaint(0); } }
				is_long = 0; 
				break;
			
			case KEY_RIGHT: 
				if (is_long == 0) MoveCursor(5); 
				is_long = 0; 
				break;
	} }
	
	if (type == EVT_KEYPRESS) {
		switch (par1) {

			case KEY_PLUS:
				if (file_mode == 0){
					BookChange(cursor, 0);
				}else{
					if (fpage*30 < books_in_dir){ fpage++; keep_scandir = 1; mainscreen_repaint(0); }
				}
				break;

			case KEY_MINUS:
				if (file_mode == 0){
					BookChange(cursor, 1);
				}else{
					if (fpage > 1){ fpage--; keep_scandir = 1; mainscreen_repaint(0); } else { DirUp(); mainscreen_repaint(0); }
				}
				break;

			case KEY_UP:
				MoveCursor(-1);
				break;

			case KEY_DOWN:
				MoveCursor(1);
				break;

			case KEY_MUSIC:
				Open_Menu();
				break;

			case KEY_DELETE:
				if (file_mode == 0) file_mode = 1; else file_mode = 0;
				mainscreen_repaint(0);
				break;

			case KEY_BACK:
				if (file_mode == 0){
					ShowInfo(cursor);
				}else{
					DirUp(); mainscreen_repaint(0);
				}
				break;

			case KEY_POWER:	
				//ShowInfo(cursor); 
				break;
		}
	}

	if (type == EVT_EXIT) {
		// occurs only in main handler when exiting or when SIGINT received - save configuration here, if needed
		WriteString(ini, "dir", now_dir);
		WriteInt(ini, "sort_mode", sort_mode);
		SaveConfig(ini);
	}
	return 0;
}



int main(int argc, char **argv) {
	if (argc == 2 && strcmp(argv[1] , "-select") == 0) {	// command line option
		is_in_select_mode = 1; 
	}else{ 
		for (ii=select_index; ii<=remove_deleted_books_index+1; ii++){ menu1[ii] = menu1[ii+1]; menu1_rus[ii] = menu1_rus[ii+1]; }
		remove_deleted_books_index -= 1;
	}
	InkViewMain(main_handler);
	return 0;
}

